q=0.01
sim=1
set.seed(sim)
runif_2seg=function(x, a,b,c,d){
    sapply(1:x, function(z){
    tmp.slot=sample(c(1,2),1, prob=c(0.5,0.5));
    if (tmp.slot==1){
         return(runif(1, a,b))
    } else{
        return(runif(1,c,d))
   }})
}


N=1000
library(mvtnorm)
library(kinship)
#Simulate genotypes
g=NULL

p=1-q
n_total=0
famid=NULL
age_c=NULL
for (i in 1:N){
     ni=sample((3:6),1)
     n_total=n_total+ni
     famid=c(famid, rep(i, ni))
     
    tmp=sample(0:2,size=2, replace=T, prob=c(p^2, 2*p*q, q^2))
    if (tmp[1]==tmp[2]){
        tmp=rep(tmp[1],ni)
    } else if ((tmp[1]+tmp[2]) %% 2 ==1) {
        tmp2=sample(tmp, size=(ni-2), replace=T, prob=c(1/2, 1/2))
        tmp=c(tmp, tmp2)
    } else {
        tmp=c(tmp, rep(1,(ni-2)))
    }
    g=c(g, tmp)

#simulate age     
        kid1=runif(1, 30, 50)
        if (ni>3){
            otherkids=runif_2seg((ni-3), (kid1-5), (kid1-1), (kid1+1), (kid1+5))  
        } else{
            otherkids=NULL
        }
        mo.age=runif(1, max(c(kid1, otherkids))+20, min(c(kid1, otherkids))+45)
        fa.age=max(runif(1, (mo.age-5), (mo.age+5)), max(c(kid1, otherkids))+20)
        age_c=c(age_c,  fa.age, mo.age, kid1, otherkids)


}
  

id=1:n_total
ped=data.frame(famid, id)
A=rep(0,3)

#simulate two phenotypes

y1=NULL
y2=NULL
sigmaA=matrix(c(0.5, 0.25, 0.25, 0.5), ncol=2, nrow=2)
hersq=0.5
sigmaE=sigmaA*(1-hersq)/hersq

for (i in unique(famid)){
        sub.fam=(famid==i)
        ni=sum(sub.fam)
        tmp=matrix(0, ncol=3, nrow=ni)

        tmp[-c(1,2),1:2]=rep(id[sub.fam][1:2], each=(ni-2))
        tmp[,3]=c(1,2,sample(c(1,2), (ni-2), replace=T, prob=c(0.5,0.5)))
        A=rbind(A, tmp)
        ped.tmp=cbind(ped[sub.fam,], tmp)
        kmat.tmp=makekinship(ped.tmp[,1], ped.tmp[,2], ped.tmp[,3], ped.tmp[,4])
        kmat.tmp=as.matrix(kmat.tmp)

          id.tmp=ped[sub.fam, "id"]
    id.tmp=as.character(id.tmp)
    covmat=kronecker(sigmaA, 2*kmat.tmp[id.tmp,id.tmp])+kronecker(sigmaE, diag(1,ni))   
   
     while (any(tmp<=0)){
         y.mean1=0.025*age_c[sub.fam]+0.5*tmp[, 3]
         y.mean2=0.04*age_c[sub.fam]+0.2*tmp[, 3]
         tmp=rmvnorm(n=1, mean=c(y.mean1, y.mean2), sigma=covmat)
     }
     y1=c(y1, tmp[1:ni])
     y2=c(y2, tmp[(ni+1):(2*ni)])

}
A=A[-1,]
colnames(A)=c("fa", "mo", "sex")
ped=cbind(ped, A)
ped=data.frame(ped)

kmat=makekinship(ped$famid,ped$id,ped$fa,ped$mo);


##BivarEGEE
phen1=y1
y2.cutoff=quantile(y2, 0.7)
phen2=as.numeric(y2>=y2.cutoff)
data=data.frame(id, famid, age_c, sex=ped$sex, phen1, phen2, g)

source("BivarEGEE.r")
test1=BivarEGEE(phen1~age_c+sex, phen2~age_c+sex, "g", "id", "famid", data, kmat, tol=10^(-8), restricted=FALSE)


##BivarBinEGEE
source("BivarBinEGEE.r")
phen1=as.numeric(y1>=quantile(y1, 0.8))
y2.cutoff=quantile(y2, 0.7)
phen2=as.numeric(y2>=y2.cutoff)
data=data.frame(id, famid, age_c, sex=ped$sex, phen1, phen2, g)
test2=BivarBinEGEE(phen1~age_c+sex, phen2~age_c+sex, "g", "id", "famid", data, kmat, tol=10^(-8), restricted=FALSE)

##BinEGEE
source("BinEGEE.r")
y2.cutoff=quantile(y2, 0.7)
phen2=as.numeric(y2>=y2.cutoff)
data=data.frame(id, famid, age_c, sex=ped$sex,  phen2, g)

test3=BinEGEE(phen2~age_c+sex,  "g", "id", "famid", data, kmat, tol=10^(-8), restricted=FALSE)

test4=BinEGEE(phen2~age_c+sex,  "g", "id", "famid", data, kmat, tol=10^(-8), restricted=T)

